#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
reload(sys)
sys.setdefaultencoding('utf8')
import subprocess
from PyQt4.QtGui import QApplication
from enums import DisplayMode


class DisplayService:

    current_display_mode = DisplayMode.MODE_ONLY_ORI

    def switch_display(self, target_mode):
        XRANDR_STATUS = "xrandr -q"

        handle = subprocess.Popen(XRANDR_STATUS, shell=True, stdout=subprocess.PIPE)
        handle.wait()
        res = handle.communicate()[0]
        lines = res.split("\n")
        monitors = []

        for line in lines:
            if(line.find(" connected ") != -1):
                name = line[ : line.find(" ")]
                monitors.append(name)

        print "found monitor :", monitors

        if(len(monitors) < 2):
            handle = subprocess.Popen("xrandr --output " + monitors[0] + " --auto", shell=True, stdout=subprocess.PIPE)
            handle.wait()
            self.current_display_mode = DisplayMode.MODE_ONLY_ORI
            print "only one monitor, do nothing."
            return (self.current_display_mode, False)

        else:
            XRANDR_ORIONLY = "xrandr --output " + monitors[0] + " --auto --output " + monitors[1] + " --off"
            XRANDR_CLONE = "xrandr --output " + monitors[0] + " --auto --output " + monitors[1] + " --same-as " + monitors[0] + " --auto"
            XRANDR_EXTEND = "xrandr --output " + monitors[0] + " --auto --output " + monitors[1] + " --right-of " + monitors[0] + " --auto"
            XRANDR_OUTONLY = "xrandr --output " + monitors[0] + " --off --output " + monitors[1] + " --auto"

            try:
                if(target_mode == DisplayMode.MODE_ONLY_ORI):
                    handle = subprocess.Popen(XRANDR_ORIONLY, shell=True, stdout=subprocess.PIPE)
                    handle.wait()
                    self.current_display_mode = DisplayMode.MODE_ONLY_ORI

                elif(target_mode == DisplayMode.MODE_CLONE):
                    handle = subprocess.Popen(XRANDR_CLONE, shell=True, stdout=subprocess.PIPE)
                    handle.wait()
                    self.current_display_mode = DisplayMode.MODE_CLONE

                elif(target_mode == DisplayMode.MODE_EXTEND):
                    handle = subprocess.Popen(XRANDR_EXTEND, shell=True, stdout=subprocess.PIPE)
                    handle.wait()
                    self.current_display_mode = DisplayMode.MODE_EXTEND

                elif(target_mode == DisplayMode.MODE_ONLY_OUT):
                    handle = subprocess.Popen(XRANDR_OUTONLY, shell=True, stdout=subprocess.PIPE)
                    handle.wait()
                    self.current_display_mode = DisplayMode.MODE_ONLY_OUT

                return (self.current_display_mode, True)
            except Exception, e:
                print e
                return (self.current_display_mode, False)


def main():
    app = QApplication(sys.argv)

    w = DisplayService()
    w.switch_display()

    sys.exit(app.exec_())


if __name__ == '__main__':
    main()
