#!/usr/bin/python
# -*- coding: utf-8 -*-


import sys
reload(sys)
sys.setdefaultencoding('utf8')
import struct
from PyQt4.QtGui import QApplication
from PyQt4.QtCore import QThread
from enums import Signals, Keys


class KeyService:

    main_window = None
    kts = []

    def __init__(self, main_window):
        self.main_window = main_window

    def get_keyboard_event_number(self):
        KBDNAME1 = "keyboard"
        KBDNAME2 = "Keyboard"

        content = ""
        events = []

        f = open("/proc/bus/input/devices", "rb")
        for line in f:
            content += line

        content1 = content
        while(content1.find(KBDNAME1) != -1):
            content1 = content1[content1.find(KBDNAME1) + 8 : ]
            handlersIndex = content1.find("H: Handlers=")
            content1 = content1[handlersIndex : ]
            line = content1[ : content1.find("\n")]
            result = line[line.find("event") : ].split()[0].strip()
            events.append(result)

        content2 = content
        while (content2.find(KBDNAME2) != -1):
            content2 = content2[content2.find(KBDNAME2) + 8:]
            handlersIndex = content2.find("H: Handlers=")
            content2 = content2[handlersIndex:]
            line = content2[: content2.find("\n")]
            result = line[line.find("event"):].split()[0].strip()
            events.append(result)

        print "found keyboard :", events
        return events

    def start_key_threads(self):
        events = self.get_keyboard_event_number()

        if(len(events) == 0):
            sys.exit("no keyboard found, exit.")

        for event_name in events:
            kt = KeyThread(event_name)
            self.main_window.connect(kt, Signals.signal_switch_select, self.main_window.slot_switch_select)
            self.main_window.connect(kt, Signals.signal_switch_confirm, self.main_window.slot_switch_confirm)
            self.kts.append(kt)
            kt.start()


class KeyThread(QThread):

    event_name = ""
    is_modify_key_press = False
    is_active = False

    def __init__(self, event_name):
        QThread.__init__(self)

        self.event_name = event_name

    def run(self):
        self.listen_global_keyboard()

    def listen_global_keyboard(self):
        infile_path = "/dev/input/" + self.event_name

        #long int, long int, unsigned short, unsigned short, unsigned int
        FORMAT = 'llHHI'
        EVENT_SIZE = struct.calcsize(FORMAT)

        in_file = open(infile_path, "rb")
        event = in_file.read(EVENT_SIZE)

        while event:
            (tv_sec, tv_usec, _type, code, value) = struct.unpack(FORMAT, event)

            if(_type == 1):
                # 键盘按下事件
                if(value == 1):
                    # print("type %u, code %u, XIA"  % (_type, code))
                    if(code == Keys.KEY_MODIFY):
                        self.is_modify_key_press = True
                    if(code == Keys.KEY_F3 or code == Keys.KEY_F7 or code == Keys.KEY_P):
                        if(self.is_modify_key_press == True):
                            self.is_active = True
                            self.emit(Signals.signal_switch_select)

                # 键盘释放事件
                elif(value == 0):
                    # print("type %u, code %u, SHANG"  % (_type, code))
                    if(code == Keys.KEY_MODIFY):
                        self.is_modify_key_press = False
                        if(self.is_active == True):
                            self.is_active = False
                            self.emit(Signals.signal_switch_confirm)

            event = in_file.read(EVENT_SIZE)

        in_file.close()


def main():
    app = QApplication(sys.argv)
    sys.exit(app.exec_())


if __name__ == '__main__':
    main()
